﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SelectedItemsInMVVM
{
    class MainViewModel : INotifyPropertyChanged
    {
        public MainViewModel()
        {
            
            Employess = new ObservableCollection<Employee>();
            Employess.Add(new Employee() { EmpId = 1, EmpName = "abhay" });
            Employess.Add(new Employee() { EmpId = 2, EmpName = "girish" });
            Employess.Add(new Employee() { EmpId = 3, EmpName = "kunal" });
            Employess.Add(new Employee() { EmpId = 4, EmpName = "avinash" });

            SelectedEmployess = new ObservableCollection<object>();
            SelectedEmployess.CollectionChanged +=SelectedEmployess_CollectionChanged;
        }

        private void SelectedEmployess_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            this.SelectedEmployess = sender as ObservableCollection<object>;
        }

        private ObservableCollection<Employee> _Employess;

        public ObservableCollection<Employee> Employess
        {
            get { return _Employess; }
            set 
            { 
                _Employess = value;
                OnPropertyChanged("Employess"); 
            }
        }

        private ObservableCollection<object> _SelectedEmployess;

        public ObservableCollection<object> SelectedEmployess
        {
            get { return _SelectedEmployess; }
            set
            {
                if (_SelectedEmployess == null)
                _SelectedEmployess = value;
                OnPropertyChanged("SelectedEmployess");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
